###############################################################################
# MessageIndex.pl                                                             #
###############################################################################
# Yet another Bulletin Board (http://www.yabb.com.ru)                         #
# Open Source project started by Zef Hemel (zef@zefnet.com)                   #
# =========================================================================== #
# Copyright (c) The YaBB Programming team                                     #
# =========================================================================== #
# This file has been written by: Zef Hemel                                    #
###############################################################################

$openfolder = "<img src=\"$imagesdir/open.gif\" border=0>";

&guest_login;
sub MessageIndex {

open (FILE, "$boardsdir/$currentboard.txt") || &fatal_error("$MessageIndex{'1'} $currentboard.txt");
&lock(FILE);
@messages = <FILE>;
&unlock(FILE);
close(FILE);

open(FILE, "$vardir/cat.txt");
&lock(FILE);
@categories = <FILE>;
&unlock(FILE);
close(FILE);
&DPPrivate;
$messagecount = 0;
$threadcount = 0;

for ($a = 0; $a < @messages; $a++) {

        ($mnum[$a],$msub[$a],$mname[$a],$memail[$a],$mdate[$a],$mreplies[$a],$musername[$a],$micon[$a],$mstate[$a]) = split(/\|/,$messages[$a]);

        $messagecount++;
        if ($mfollow[$a] == 1) {
                $threadcount++;
        }
        $micon[$a] =~ s/[\n\r]//g;

}
$writedate = "$mdate[0]";
&writelog("$currentboard");

if (@moderators==1) {
        $showmods = "($MessageIndex{'2'}: ";
} else {
        $showmods = "($MessageIndex{'3'}: ";
}

foreach $muname (keys %moderators) {
        $showmods .= "<a href=\"$boardurl/YaBB.pl?board=&action=viewprofile&username=$muname\">$moderators{$muname}</a>, ";
}

$showmods =~ s/, $//;
$showmods .= ")";

$title = "$boardname";
&header;
if ($maxdisplay > 0 && @messages > $maxdisplay) {
        $themax = $maxdisplay
} else {
        $themax = "all";
}
print <<"EOT";
<table width=100%>
<tr>
EOT
if ($nav_art eq "1") {
print <<"EOT";
<td valign=bottom><font size=$Fontsize face="$FontFace">$closedfolder &nbsp\;<a href="$boardurl/YaBB.pl">$mbname</a>&nbsp\; $openfolder &nbsp\; $boardname  $showmods</font></td>
<td align=right><font size=$Fontsize face="$FontFace"><a href="$cgi&action=markasread"><img src="$imagesdir/markasread.gif" alt="$MessageIndex{'4'}" border="0"></a><a href="$cgi&action=post&title=$MessageIndex{'5'}"><img src="$imagesdir/new_thread.gif" alt="$MessageIndex{'5'}" border="0"></a></font></td>
EOT
} else {
print <<"EOT";
<td><FONT SIZE="1" FACE="Verdana, Arial">
<IMG SRC="$imagesdir/folder-1p.gif" WIDTH=18 HEIGHT=20 ALIGN=middle BORDER=0>&nbsp;&nbsp;<A href="$boardurl/YaBB.pl">$mbname</A><br>
<IMG SRC="$imagesdir/folder-2.gif" WIDTH=38 HEIGHT=20 ALIGN=middle BORDER=0>&nbsp;&nbsp;$boardname  $showmods</font></td>
<td align=right><font size=$Fontsize face="$FontFace"><a href="$cgi&action=markasread"><img src="$imagesdir/markasread.gif" alt="$MessageIndex{'4'}" border="0"></a><a href="$cgi&action=post&title=$MessageIndex{'5'}"><img src="$imagesdir/new_thread.gif" alt="$MessageIndex{'5'}" border="0"></a></font></td>
EOT
}
print <<"EOT";
</tr>
</table>
<table border=0 width=100% cellspacing=1 cellpadding=2 bgcolor="$color{'frame'}">
<tr>
        <td bgcolor="$color{'titlebg'}" width=16><font size=$Fontsize face="$FontFace">&nbsp;</font></td>
        <td bgcolor="$color{'titlebg'}" width=16><font size=$Fontsize face="$FontFace">&nbsp;</font></td>
        <td bgcolor="$color{'titlebg'}" width="*"><font size=$Fontsize color="$color{'titletext'}" face="$FontFace"><b>$MessageIndex{'6'}</b></font></td>
        <td bgcolor="$color{'titlebg'}" width="15%" align=center><font size=$Fontsize color="$color{'titletext'}" face="$FontFace"><b>$MessageIndex{'7'}</b></font></td>
        <td bgcolor="$color{'titlebg'}" width="10%" align=center><font size=$Fontsize color="$color{'titletext'}" face="$FontFace"><b>$MessageIndex{'8'}</b></font></td>
        <td bgcolor="$color{'titlebg'}" width="10%" align=center><font size=$Fontsize color="$color{'titletext'}" face="$FontFace"><b>$MessageIndex{'9'}</b></font></td>
        <td bgcolor="$color{'titlebg'}" width="19%" align=center><font size=$Fontsize color="$color{'titletext'}" face="$FontFace"><b>$MessageIndex{'10'}</b></font></td>
EOT
if($INFO{'start'} eq "") { $start=0; } else { $start="$INFO{'start'}"; }
$numshown=0;
open(CENSOR, "$vardir/censor.txt");
&lock(CENSOR);
@censored = <CENSOR>;
&unlock(CENSOR);
close(CENSOR);

for ($b = $start; $b < @messages; $b++) {
        ++$numshown;
        if($mstate[$b]==0) { $type="thread"; }
        if($mreplies[$b]>=$hot1) { $type="hotthread"; }
        if($mreplies[$b]>=$hot2) { $type="veryhotthread"; }
        if($mstate[$b]==1) { $type="locked"; }
        $dlp = &readlog("$mnum[$b]");
        $new="";
        $date1="$mdate[$b]";
        $date2="$date";
        &calcdifference2;
        if($dlp ne "$date1" && $result <= $max_log_days_old && $username ne "Guest") {
                $new = "<img src=\"$imagesdir/new.gif\">";
        }
        ##################
        foreach $censor (@censored) {
                $censor =~ s/[\n\r]//g;
                ($word, $censored) = split(/\=/, $censor);
                $msub[$b] =~ s/$word/$censored/gi;
        }
        ##################
        $nummessages=$mreplies[$b]+1;
        $c=0;
        $pages="";
        if($nummessages>$maxmessagedisplay) {
                while(($c*$maxmessagedisplay)<$nummessages) {
                        $viewc = $c+1;
                        $strt = ($c*$maxmessagedisplay);
                        $pages = <<"EOT";
$pages<a href="$cgi&action=display&num=$mnum[$b]&start=$strt">$viewc</a>
EOT
                        ++$c;
                }
                $pages =~ s/\n$//g;
                $pages = "<font size=$Fontsize1 face=\"$FontFace\">($pages)</font>";
        }
                $filetoopen = "$mnum[$b]" . ".data";
                open(FILE2, "$datadir/$filetoopen");
                &lock(FILE2);
                $tempinfo = <FILE2>;
                &unlock(FILE2);
                close(FILE2);

                ($views, $lastposter) = split(/\|/,$tempinfo);

                if ($lastposter eq "") { $lastposter = "-"; }
                if ($views eq "") { $views = "0"; }
        if ($mreplies[$b] eq "-1") { $mreplies[$b] = "-"; }
                if ($musername[$b] eq "") { $musername[$b] = "$mname[$b]"; } else { $musername[$b] = "$musername[$b]";}
        if ($musername[$b] eq "Guest") { $musername[$b] = "$mname[$b]"; } else { $musername[$b] = "$musername[$b]";}
print <<"EOT";
<tr>
        <td width=16 bgcolor="$color{'windowbg2'}" align=center valign=center><img src="$imagesdir/$type.gif"></td>
        <td width=16 bgcolor="$color{'windowbg2'}" align=center valign=center><img src="$imagesdir/$micon[$b].gif" alt="" border="0" align=middle></td>
        <td valing=top width="*" bgcolor="$color{'windowbg'}"><font size=$Fontsize face="$FontFace"><a href="$cgi&action=display&num=$mnum[$b]"><b>$msub[$b]</b></a> $new $pages</font></td>
        <td valing=top width="15%" align=center bgcolor="$color{'windowbg2'}"><font size=$Fontsize face="$FontFace"><a href=$boardurl/YaBB.pl?board=test1&action=viewprofile&username=$musername[$b]>$musername[$b]</a></font></td>
        <td valing=top width="10%" align=center bgcolor="$color{'windowbg'}"><font size=$Fontsize face="$FontFace">$mreplies[$b]</font></td>
        <td valing=top width="10%" align=center bgcolor="$color{'windowbg'}"><font size=$Fontsize face="$FontFace">$views</font></td>
        <td valing=top width="19%" align=center bgcolor="$color{'windowbg2'}"><font size=$Fontsize1 face="$FontFace">$mdate[$b]<br>
        $MessageIndex{'11'} <a href=$boardurl/YaBB.pl?board=test1&action=viewprofile&username=$lastposter>$lastposter</a></font></td>
</tr>

EOT

$lastposter = "";

        if ($numshown >= $maxdisplay && $INFO{'view'} ne 'all') { $b = @messages; }
}
print <<"EOT";
</table>
<table border=0 width=100% cellpadding=3>
<tr><td>
<font size=$Fontsize face="$FontFace"><b>$MessageIndex{'12'}:</b>
EOT
$nummessages=@messages;
$c=0;
while(($c*$maxdisplay)<$nummessages) {
        $viewc = $c+1;
        $strt = ($c*$maxdisplay);
        if($start == $strt) {
                print <<"EOT";
$viewc
EOT
        } else {
                print <<"EOT";
<a href="$cgi&action=messageindex&start=$strt">$viewc</a>
EOT
        }
        ++$c;
}
&jumpto;
print <<"EOT";
</font></td><td>&nbsp;</td><td align=right>
<font size=$Fontsize face="$FontFace"><a href="$cgi&action=markasread"><img src="$imagesdir/markasread.gif" alt="$MessageIndex{'4'}" border="0"></a><a href="$cgi&action=post&title=$MessageIndex{'5'}"><img src="$imagesdir/new_thread.gif"alt="$MessageIndex{'5'}" border="0"></a></font>
</td></tr>
<tr>
    <td align="left" valign="middle"><font size=1>
    <img src="$imagesdir/hotthread.gif"> $MessageIndex{'15'}
    <BR><img src="$imagesdir/veryhotthread.gif"> $MessageIndex{'16'}</td>
    <td align="left" valign="middle"><font size=1>
    <img src="$imagesdir/locked.gif"> $MessageIndex{'17'}
    <BR><img src="$imagesdir/thread.gif"> $MessageIndex{'18'}</font></td>
    <td align="right">
    <form action="YaBB.pl" method="GET">
    <font size=$Fontsize1 face="$FontFace">$MessageIndex{'13'}: <select name="board">$selecthtml</select> <input type=submit value="$MessageIndex{'14'}"></form>
    </td>
  </tr></table>
EOT
&footer;
exit;
}

1;