###############################################################################
# Search.pl                                                                   #
###############################################################################
# Yet another Bulletin Board (http://www.yabb.com.ru)                         #
# Open Source project started by Zef Hemel (zef@zefnet.com)                   #
# =========================================================================== #
# Copyright (c) The YaBB Programming team                                     #
# =========================================================================== #
# This file has been written by: Christian Land                               #
#                                (based on an idea by Matthew Mecham)         #
# =========================================================================== #
# Special thanks to Sebastian Schipper for his help :o)                       #
###############################################################################

# Parameter in der URL
#
# mode  : keywords        Nach Schlsselwrtern suchen (mit , getrennt)
#           startedby        Nach Threads suchen die von jemandem gestartet wurden
#         postedby        Nach Threads suchen in denen jemand geschrieben hat
#
# case  : 0 - Gross-Kleinschreibung ignorieren
#          1 -           "           beachten
#
# words : 0 - Wrter knnen teil eines anderen Wortes sein ("ein" findet z.b. ein, kein, bein)
#         1 - Nur ganze Worte

#####
#
# Display Search-Form
#
#####

sub SearchForm {

        $title="$Search{'1'}";
        &header;
        &menu2;

        # Display Search-Form
            print <<"EOT";
<table border=0 width=100% cellspacing=$frameborder bgcolor="$color{'frame'}">
 <tr>
  <td bgcolor="$color{'titlebg'}">
   <font size=2 color="$color{'titletext'}"><b>$Search{'2'}</b></font>
  </td>
 </tr>
 <tr>
  <td bgcolor="$color{'windowbg'}">
   <font size=2>
    <br>
EOT
        &ShowForm;
        if ($oldresults) {
                print "<br>$Search{'3'} <a href=\"$cgi&action=search3\">$Search{'4'}</a> $Search{'23'}";
        }
        print <<"EOT";
    <br>&nbsp;
   </font>
  </td>
 </tr>
</table>
EOT

        &footer;
        exit;

}

#####
#
# Display Results
#
#####

sub DisplayResults {

        $title = "$Search{'6'}";

        &header;

        if($username eq "Guest") {
                $tip=$ENV{'REMOTE_ADDR'};
                $tip =~ s/\./-/g;
                $tuser = "guest_res$tip.search";
        } else {
                $tuser = $username;
        }

            print <<"EOT";
<table border=0 width=100% cellspacing=$frameborder bgcolor="$color{'frame'}">
 <tr>
  <td bgcolor="$color{'titlebg'}">
   <font size=2 color="$color{'titletext'}"><b>$Search{'7'}</b></font>
  </td>
 </tr>
 <tr>
  <td bgcolor="$color{'windowbg'}">
   <font size=2>
EOT

        if (-e "$memberdir/search/$tuser.search") {
                # Display Form
                &ShowForm;

                # read all results

                open(FILE, "$memberdir/search/$tuser.search");
                &lock(FILE);
                @results = <FILE>;
                &unlock(FILE);
                close(FILE);
        $anzahlresults = @results;
            print <<"EOT";
   </font>
  </td>
 </tr>
</table>
<br>
<table border=0 width=100% cellspacing=$frameborder bgcolor="$color{'frame'}">
 <tr>
  <td bgcolor="$color{'titlebg'}">
   <font size=2 color="$color{'titletext'}"><b>$Search{'6'}</b> - $anzahlresults $Search{'5'}</font>
  </td>
 </tr>
 <tr>
  <td bgcolor="$color{'windowbg'}">
   <font size=2>
EOT


                # Display Results

                foreach $sresult (@results) {

                        $sresult =~ s/[\n\r]//g;
                        ($threadtitle_var,$messagenumber_var,$messagetitle_var,$poster_var,$date_var,$counter,$snippet_var,$foundword_var,$board) = split(/\|/,$sresult);

                        print "<br><font size=1><b><a href=\"$boardurl/YaBB.pl?board=$threadtitle_var&action=display&num=$messagenumber_var\" target=\"_blank\">$messagetitle_var</a> ($Search{'8'} <a href=\"$boardurl/YaBB.pl?board=&action=viewprofile&username=$counter\">$poster_var</a> $Search{'24'} $date_var)</b></font><br><br>$snippet_var<br><hr>";

                }

        } else {

                print "$Search{'9'}";

        }

            print <<"EOT";
    <br>&nbsp;
   </font>
  </td>
 </tr>
</table>
EOT
        &footer;
        exit;

}

#####
#
# Search
#
#####

sub DoSearch {

        $snippetsize = 250;                # Maximale Anzahl von Zeichen die zu einem Beitrag angezeigt werden

        # Create Filename

        if($username eq "Guest") {
                $tip=$ENV{'REMOTE_ADDR'};
                $tip =~ s/\./-/g;
                $tuser = "guest_res$tip.search";
        } else {
                $tuser = $username;
        }

        # Save Parameters

        open(FILE, ">$memberdir/search/$tuser.sparams");
        &lock(FILE);
        print FILE "$date\|$FORM{'category'}\|$FORM{'mode'}\|$FORM{'searchstring'}\|$FORM{'case'}\|$FORM{'words'}\n";
        &unlock(FILE);
        close(FILE);

        # Fill @categories

        if($FORM{'category'} eq "all") {

                open(FILE, "$vardir/cat.txt");
                &lock(FILE);
                @categories = <FILE>;
                &unlock(FILE);
                close(FILE);

        } else {

                push(@categories,$FORM{'category'});

        }

        # Search

        unlink("$memberdir/search/$tuser.search");

        #unlink("$memberdir/search/$username.sparams");

        $mastercount = 0;

        foreach $curcat (@categories) {

                $curcat =~ s/[\n\r]//g;

                open(CAT, "$boardsdir/$curcat.cat");
                &lock(CAT);
                @catinfo = <CAT>;
                &unlock(CAT);
                close(CAT);

                $catinfo[1] =~ s/[\n\r]//g;        # Member Groups with Access to this Board

                if (%membergroups>0) {
                        undef %membergroups;
                }

                # Create Hash %membergroups with all Moderators of the current board

                foreach(split(/,/,$catinfo[1])) {
                        if ($_ ne "") {
                                $membergroups{$_} = "OK";
                        }
                }

                $curcatname="$catinfo[0]";

                # Remove the first 2 Elements of the Array

                shift(@catinfo);        # remove line with Category-Name
                shift(@catinfo);        # remove line with allowed groups

                # Check if User is allowed to access Board
                # exists $membergroups{$settings[7]}        -> User is in right Membergroup
                # $settings[7] eq "$Administrator"        -> User is Admin
                # %membergroups==0                        -> No access restrictions for this Category

                if (exists $membergroups{$settings[7]} || $settings[7] eq "Administrator" || %membergroups==0) {

                        # Go thru all cats

                        foreach $curboard (@catinfo) {

                                $curboard =~ s/[\n\r]//g;

                                # Read all threads

                                open(FILE, "$boardsdir/$curboard.txt") || &fatal_error("$Search{'10'} $boarddir/$currentboard.txt");
                                &lock(FILE);
                                @threads = <FILE>;
                                &unlock(FILE);
                                close(FILE);

                                ################################ Search ################################

                                if ($FORM{'mode'} eq "startedby") {

                                        # Search for all Threads which were started by a certain user

                                        $wordsearch = $FORM{'searchstring'};
                                        @names = split (/,/,$wordsearch);

                                        foreach $thread (@threads) {

                                                $thread =~ s/[\n\r]//g;
                                                ($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split(/\|/,$thread);

                                                foreach $name (@names) {

                                                        if ($FORM{'case'} eq "1") {
                                                                if ($FORM{'words'} ne "1") {
                                                                        $found = $mname =~ /$name/sg ? "1" : "0";
                                                                        if($found==0) {
                                                                                $found = $musername =~ /$name/sg ? "1" : "0";
                                                                        }
                                                                } else {
                                                                    $found = $mname eq $name ? "1" : "0";
                                                                    if ($found==0) {
                                                                        $found = $musername eq $name ? "1" : "0";
                                                                    }
                                                                }
                                                        } else {
                                                                if ($FORM{'words'} ne "1") {
                                                                        $found = $mname =~ /$name/sgi ? "1" : "0";
                                                                        if ($found==0) {
                                                                            $found = $mname =~ /$name/sgi ? "1" : "0";
                                                                        }
                                                                } else {
                                                                        $found = lc $mname eq lc $name ? "1" : "0";
                                                                        if ($found==0) {
                                                                                $found = lc $musername eq lc $name ? "1" : "0";
                                                                        }
                                                                }
                                                        }

                                                        if ($found eq "1") {

                                                                open(FILE, "$datadir/$mnum.txt") || &fatal_error("$Search{'10'} $mnum.txt");
                                                                &lock(FILE);
                                                                @messages = <FILE>;
                                                                &unlock(FILE);
                                                                close(FILE);

                                                                ($msubject, $mname, $memail, $mdate, $musername, $micon, $mattache, $mip, $mmessage) = split(/\|/,$messages[0]);

                                                                # remove all YaBB-Codes from Message

                                                                $mmessage =~ s/\[.+?\]//g;

                                                                $snippet = substr($mmessage, 0, $snippetsize);

                                                                # save result for later use *g*

                                                                $threadtitle_var[$mastercount] = $curboard;
                                                                $messagenumber_var[$mastercount] = $mnum;
                                                                $messagetitle_var[$mastercount] = $msubject;
                                                                $poster_var[$mastercount] = $mname;
                                                                $date_var[$mastercount] = $mdate;
                                                                $counter[$mastercount] = $musername; #$mastercount;
                                                                $snippet_var[$mastercount] = $snippet;
                                                                $foundword_var[$mastercount]= $word;
                                                                $mastercount++;

                                                        }

                                                }

                                        }

                                        # Save Search-Results to disk to speed things up...

                                        if($mastercount>0) {

                                                open(FILE, ">$memberdir/search/$tuser.search");
                                                &lock(FILE);
                                                for($i=0;$i<$mastercount;$i++) {
                                                        print FILE "$threadtitle_var[$i]\|$messagenumber_var[$i]\|$messagetitle_var[$i]\|$poster_var[$i]\|$date_var[$i]\|$counter[$i]\|$snippet_var[$i]\|$foundword_var[$i]\n";
                                                }
                                                &unlock(FILE);
                                                close(FILE);

                                        }

                                } elsif ($FORM{'mode'} eq "keywords") {

                                        $wordsearch = $FORM{'searchstring'};

                                        # Search for all Threads with certain keywords

                                        @keywords = split (/,/,$wordsearch);

                                        foreach $thread (@threads) {

                                                ($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split(/\|/,$thread);

                                                # Read all Messages in thread

                                                open(FILE, "$datadir/$mnum.txt") || &fatal_error("$Search{'10'} $mnum.txt");
                                                &lock(FILE);
                                                @messages = <FILE>;
                                                &unlock(FILE);
                                                close(FILE);

                                                # Search

                                                foreach $message (@messages) {

                                                        ($msubject, $mname, $memail, $mdate, $musername, $micon, $mattache, $mip, $mmessage) = split(/\|/,$message);

                                                        # remove all YaBB-Codes from Message

                                                        $mmessage =~ s/\[.+?\]//g;

                                                        # Search for all Keywords

                                                        foreach $word (@keywords) {

                                                                $found = 0;

                                                                if ($FORM{'case'} eq "1") {
                                                                        if ($FORM{'words'} ne "1") {
                                                                            $found = $mmessage =~ /$word/sg ? "1" : "0";
                                                                        } else {
                                                                            $found = $mmessage =~ /[\b,\.-]$word[\b,\.-]/sg ? "1" : "0";
                                                                            if ($found==0) {
                                                                                    $found = $mmessage =~ /^$word[\b,\.-]/sg ? "1" : "0";
                                                                            }
                                                                            if ($found==0) {
                                                                                    $found = $mmessage =~ /[\b,\.-]$word$/sg ? "1" : "0";
                                                                            }
                                                                        }
                                                                } else {
                                                                        if ($FORM{'words'} ne "1") {
                                                                            $found = $mmessage =~ /$word/sgi ? "1" : "0";
                                                                        } else {
                                                                            $found = $mmessage =~ /[\b,\.-]$word[\b,\.-]/sgi ? "1" : "0";
                                                                            if ($found==0) {
                                                                                    $found = $mmessage =~ /^$word[\b,\.-]/sgi ? "1" : "0";
                                                                            }
                                                                            if ($found==0) {
                                                                                    $found = $mmessage =~ /[\b,\.-]$word$/sgi ? "1" : "0";
                                                                            }
                                                                        }
                                                                }

                                                                if ($found eq "1") {

                                                                        $snippet = substr($mmessage, 0, $snippetsize);

                                                                        # mark Searchstring in Result...

                                                                        if ($FORM{'words'} eq "0") {
                                                                            $snippet =~ s/$word/<b>$word<\/b>/sgi;
                                                                        } else {
                                                                                $snippet =~ s/[\b,\.-]$word[\b,\.-]/<b>$word<\/b>/sgi;
                                                                                $snippet =~ s/[\b,\.-]$word$/<b>$word<\/b>/sgi;
                                                                                $snippet =~ s/^$word[\b,\.-]/<b>$word<\/b>/sgi;
                                                                        }

                                                                        # save result for later use *g*

                                                                        $threadtitle_var[$mastercount] = $curboard;
                                                                        $messagenumber_var[$mastercount] = $mnum;
                                                                        $messagetitle_var[$mastercount] = $msubject;
                                                                        $poster_var[$mastercount] = $mname;
                                                                        $date_var[$mastercount] = $mdate;
                                                                        $counter[$mastercount] = $mastercount;
                                                                        $snippet_var[$mastercount] = $snippet;
                                                                        $foundword_var[$mastercount]= $word;
                                                                        $mastercount++;

                                                                } # end keyword match


                                                        } # end @keywords foreach

                                                }

                                        }

                                        # Save Search-Results to disk to speed things up...

                                        if($mastercount>0) {

                                                open(FILE, ">$memberdir/search/$tuser.search");
                                                &lock(FILE);
                                                for($i=0;$i<$mastercount;$i++) {
                                                        print FILE "$threadtitle_var[$i]\|$messagenumber_var[$i]\|$messagetitle_var[$i]\|$poster_var[$i]\|$date_var[$i]\|$counter[$i]\|$snippet_var[$i]\|$foundword_var[$i]\n";
                                                }
                                                &unlock(FILE);
                                                close(FILE);

                                        }

                                } elsif ($FORM{'mode'} eq "postedby") {

                                        # Search for all Threads where a certain user posted in

                                        $wordsearch = $FORM{'searchstring'};
                                        @names = split (/,/,$wordsearch);

                                        foreach $thread (@threads) {

                                                ($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split(/\|/,$thread);

                                                # Read all Messages in thread

                                                open(FILE, "$datadir/$mnum.txt") || &fatal_error("$Search{'10'} $mnum.txt");
                                                &lock(FILE);
                                                @messages = <FILE>;
                                                &unlock(FILE);
                                                close(FILE);

                                                # Search

                                                foreach $message (@messages) {

                                                        ($msubject, $mname, $memail, $mdate, $musername, $micon, $mattache, $mip, $mmessage) = split(/\|/,$message);

                                                        # remove all YaBB-Codes from Message

                                                        $mmessage =~ s/\[.+?\]//g;

                                                        # Search for all Keywords
                                                        foreach $name (@names) {


                                                                $found = 0;

                                                                if ($FORM{'case'} eq "1") {
                                                                        if ($FORM{'words'} ne "1") {
                                                                            $found = $mname =~ /$name/sg ? "1" : "0";
                                                                                if ($found==0) {
                                                                                        $found = $usermname =~ /$name/sg ? "1" : "0";
                                                                                }
                                                                        } else {
                                                                                $found = $mname eq $name ? "1" : "0";
                                                                                if ($found==0) {
                                                                                        $found = $musername eq $name ? "1" : "0";
                                                                                }
                                                                        }
                                                                } else {
                                                                        if ($FORM{'words'} ne "1") {
                                                                                $found = $mname =~ /$name/sgi ? "1" : "0";
                                                                                if ($found==0) {
                                                                                        $found = $mname =~ /$name/sgi ? "1" : "0";
                                                                                }
                                                                        } else {
                                                                                    $found = lc $mname eq lc $name ? "1" : "0";
                                                                                    if ($found==0) {
                                                                                            $found = lc $musername eq lc $name ? "1" : "0";
                                                                                }
                                                                        }
                                                                }

                                                                if ($found == 1) {

                                                                        $snippet = substr($mmessage, 0, $snippetsize);

                                                                        # save result for later use *g*

                                                                        $threadtitle_var[$mastercount] = $curboard;
                                                                        $messagenumber_var[$mastercount] = $mnum;
                                                                        $messagetitle_var[$mastercount] = $msubject;
                                                                        $poster_var[$mastercount] = $mname;
                                                                        $date_var[$mastercount] = $mdate;
                                                                        $counter[$mastercount] = $mastercount;
                                                                        $snippet_var[$mastercount] = $snippet;
                                                                        $foundword_var[$mastercount]= $word;

                                                                        $mastercount=$mastercount+1;

                                                                } # end keyword match

                                                        } # end @keywords foreach

                                                }

                                        }

                                        # Save Search-Results to disk to speed things up...

                                        if($mastercount>0) {

                                                open(FILE, ">$memberdir/search/$tuser.search");
                                                &lock(FILE);
                                                for($i=0;$i<$mastercount;$i++) {
                                                        print FILE "$threadtitle_var[$i]\|$messagenumber_var[$i]\|$messagetitle_var[$i]\|$poster_var[$i]\|$date_var[$i]\|$counter[$i]\|$snippet_var[$i]\|$foundword_var[$i]\$curboard\n";
                                                }
                                                &unlock(FILE);
                                                close(FILE);

                                        }

                                }

                        }

                }

        }

        &CleanUp;
        &DisplayResults;
        exit;

}

sub ShowForm {

        $sdate=undef;
        $mode="keywords";
        $category=undef;
        $searchstring=undef;
        $case=0;
        $words=0;
        $oldresults=0;

        # Create Filename

        if($username eq "Guest") {
                $tip=$ENV{'REMOTE_ADDR'};
                $tip =~ s/\./-/g;
                $tuser = "guest_res$tip.search";
        } else {
                $tuser = $username;
        }

        # Open old Search-Parameters

        if(-e "$memberdir/search/$tuser.sparams" && $username ne "Guest") {

                # read search-parameters

                open(FILE, "$memberdir/search/$tuser.sparams");
                &lock(FILE);
                $params = <FILE>;
                &unlock(FILE);
                close(FILE);

                $params =~ s/[\n\r]//g;

                $oldresults=1;
                ($sdate,$category,$mode,$searchstring,$case,$words) = split(/\|/,$params);

        }

        if ($mode eq "keywords") {
                $keywords=" selected";
        } elsif ($mode="postedby") {
                $posted=" selected";
        } elsif ($mode="startedby") {
                $started=" selected";
        }

        if ($case==1) {
                $sensitive=" checked";
        }

        if ($words==1) {
                $wholewords=" checked";
        }

        $filetoopen = "$vardir/cat.txt";
        open(FILE, "$filetoopen");
        &lock(FILE);
        @masterdata = <FILE>;
        &unlock(FILE);
        close(FILE);


        $selecthtml .= "<option value=\"\">$Search{'11'}";

        foreach $category (@masterdata) { # start to open files
                chomp $category;
                open(FILE, "$boardsdir/$category.cat");
                &lock(FILE);
                @data = <FILE>;
                &unlock(FILE);
                close(FILE);
                $data[1] =~ s/\n//g;
                if($data[1] ne "") { #begin defining private forums
                        if($settings[7] ne "$Administrator" && $settings[7] ne "$data[1]") {
                                next;
                        } # end nested if
                } # end @datainfo if

                foreach $line (@data) {
                if($line ne "$data[0]" && $line ne "$data[1]") {
                        chomp $line;
                        open(FILE, "$boardsdir/$line.dat") || next;
                        &lock(FILE);
                        @newcatdata = <FILE>;
                        &unlock(FILE);
                        close(FILE);


                        $selecthtml .= "<option value=\"$line\">$newcatdata[0]\n";

                } # end main if (private boards)

                } # end second foreach

        } # end the main foreach

        # Output Form

            print <<"EOT";
    <form action="$cgi\&action=search2" method="POST">
<table>
 <tr>
  <td>
   <font size=2>$Search{'17'}:</font>
  </td>
  <td>
        <select name="mode">
                <option value="keywords"$keywords>$Search{'12'}
                <option value="startedby"$started>$Search{'13'}
                <option value="postedby"$posted>$Search{'14'}
        </select>
</td>

<tr>
 <td><font size=2>$Search{'15'}:</font></td>
 <td>
  <select name="category">
   <option value="all">$Search{'16'}
$selecthtml
  </select>
 </td>
</tr>

<tr>
 <td><font size=2>$Search{'22'}:</font></td>
 <td><input type=text name="searchstring" size=40 value="$searchstring"></td>
</tr>

<tr>
 <td valign=top>
  <font size=2>$Search{'18'}:</font>
 </td>
 <td>
  <input type=checkbox name="case" value="1"$sensitive><font size=2>$Search{'19'}<br>
  <input type=checkbox name="words" value="1"$wholewords>$Search{'20'}</font>
 </td>
</tr>

<tr>
<td></td>
<td>
        <input type=reset value="$Search{'25'}">
        <input type=submit value="$Search{'21'}">
</td></tr></table>
    </form>
EOT

}

sub CleanUp {

        # Delete all Files from Guests which are older than 1 h
        # and all Files from Users which are older than 14 Days

        $dirtoopen = "$memberdir/search";
        opendir (DIRECTORY,"$dirtoopen");
        @dirdata = readdir(DIRECTORY);
        closedir (DIRECTORY);

        foreach $filename (@dirdata) {

                if ($filename =~ /^guest_res/) {
                        # .0416 = 1 hour -> -M returns age of file in days !
                        unlink("$memberdir/search/$filename") if -M "$memberdir/search/$filename" > .0416;
                } else {
                        unlink("$memberdir/search/$filename") if -M "$memberdir/search/$filename" > 14;
                }

        }

}

1;