###############################################################################
# ManageBoards.pl                                                             #
###############################################################################
# Yet another Bulletin Board version 1.0                                      #
# Written by Zef Hemel of Significon, 2000                                    #
###############################################################################
# Yet another Bulletin Board (http://www.yabb.com.ru)                         #
# Open Source project started by Zef Hemel (zef@zefnet.com)                   #
# =========================================================================== #
# Copyright (c) The YaBB Programming team                                     #
# =========================================================================== #
# This file has been written by: Zef Hemel                                    #
###############################################################################

sub ManageBoards {
        open(FILE, "$vardir/cat.txt");
        &lock(FILE);
        @categories = <FILE>;
        &unlock(FILE);
        close(FILE);
        $title = "$ManageBoards{'1'}";
        &header;
        &menu2;
        print <<"EOT";
<table border=0 width=100% cellspacing=$frameborder bgcolor="$color{'frame'}">
<tr>
        <td bgcolor="$color{'titlebg'}" width=10><font size=$Fontsize face="$FontFace">&nbsp;</font></td>
        <td bgcolor="$color{'titlebg'}"><font color="$color{'titletext'}" size=$Fontsize1 face="$FontFace"><b>$ManageBoards{'2'}</b></font></td>
        <td bgcolor="$color{'titlebg'}" nowrap><font color="$color{'titletext'}" size=$Fontsize1 face="$FontFace"><b>$ManageBoards{'3'}</b></font></td>
        <td bgcolor="$color{'titlebg'}" nowrap><font color="$color{'titletext'}" size=$Fontsize1 face="$FontFace"><b>$ManageBoards{'4'}</b></font></td>
</tr>
EOT
        foreach $curcat (@categories) {
                $curcat =~ s/[\n\r]//g;
                open(CAT, "$boardsdir/$curcat.cat");
                &lock(CAT);
                @catinfo = <CAT>;
                &unlock(CAT);
                close(CAT);
                $curcatname="$catinfo[0]";
                print <<"EOT";
<tr>
        <td bgcolor="#c0c0c0" width=10 valign=top><img src="$imagesdir/cat.gif" alt="" border="0"></td>
        <td colspan=3 bgcolor="#c0c0c0"><font size=$Fontsize face="$FontFace"><a href="$cgi&action=reorderboards&cat=$curcat"><b>$curcatname</b></a></font></td>
</tr>
EOT
                foreach $curboard (@catinfo) {
                        if($curboard ne "$catinfo[0]" && $curboard ne "$catinfo[1]") {
                                $curboard =~ s/[\n\r]//g;
                                open(BOARD, "$boardsdir/$curboard.dat");
                                &lock(BOARD);
                                @boardinfo = <BOARD>;
                                &unlock(BOARD);
                                close(BOARD);
                                $curboardname="$boardinfo[0]";
                                $descr="$boardinfo[1]";
                                open(BOARDDATA, "$boardsdir/$curboard.txt");
                                &lock(BOARDDATA);
                                @messages = <BOARDDATA>;
                                &unlock(BOARDDATA);
                                close(BOARDDATA);
                                ($dummy, $dummy, $dummy, $dummy, $dummy, $lp) = split(/\|/, $messages[0]);
                                $boardinfo[2] =~ s/\n//g;
                                $boardinfo[2] =~ /^\|(.*?)\|$/;
                                $multimoderators = $1 or $multimoderators = $boardinfo[2];
                                $multimoderators =~ s/\|/,/g;
                                $moderator = "$modprop[1]";
                                print <<"EOT";
<tr>
        <td bgcolor="#e0e0e0" width=10 valign=top><img src="$imagesdir/board.gif"  alt="" border="0"></td>
        <td bgcolor="#e0e0e0" width=* valign=top><font size=$Fontsize face="$FontFace">
        <form action="$cgi&action=modifyboard" method="POST">
        <input type=hidden name="id" value="$curboard">
        <input type=hidden name="cat" value="$curcat">
        <b>$ManageBoards{'5'}: </b><input type=text name="" value="$curboard" size=15 disabled>
        <b>$ManageBoards{'6'}: </b><input type=text name="boardname" value="$curboardname" size=30><br>
        <textarea name=descr cols=50 rows=3>$descr</textarea></font></td>
        <td bgcolor="#e0e0e0" valign=top width=20%><input type=text name=moderator value="$multimoderators" size=15></td>
        <td bgcolor="#e0e0e0" valign=top width=20%><input type=submit name="moda" value="$ManageBoards{'7'}">
        <input type=submit name="moda" value="$ManageBoards{'8'}"></form></td>
</tr>
EOT
                        }
                }
                print <<"EOT";
<tr>
        <td bgcolor="#e0e0e0" width=10 valign=top><img src="$imagesdir/board.gif" alt="" border="0"></td>
        <td bgcolor="#e0e0e0" width=* valign=top><font size=$Fontsize face="$FontFace">
        <form action="$cgi&action=addboard" method="POST">
        <b>$ManageBoards{'5'}: </b><input type=text name="id" value="" size=15>
        <b>$ManageBoards{'6'}: </b><input type=text name="boardname" size=30><br>
        <textarea name=descr cols=50 rows=3></textarea></font></td>
        <td bgcolor="#e0e0e0" valign=top width=20%><input type=text name=moderator value="" size=15>
        <input type=hidden name="cat" value="$curcat"></td>
        <td bgcolor="#e0e0e0" valign=top width=20%><input type=submit value="$ManageBoards{'9'}"></form></td>
</tr>
EOT
        }
        print "</table>";
        &footer;
        exit;
}

sub ReorderBoards {
        if($settings[7] ne "$Administrator") { &fatal_error("$ManageBoards{'10'}"); }
        open(FILE, "$boardsdir/$INFO{'cat'}.cat");
        &lock(FILE);
        @allboards = <FILE>;
        &unlock(FILE);
        close(FILE);
        $title = "$ManageBoards{'11'}";
        $boardlist="";
        foreach $cboard (@allboards) {
                $cboard =~ s/[\n\r]//g;
                if($cboard ne "$allboards[0]" && $cboard ne "$allboards[1]") { $boardlist="$boardlist\n$cboard"; }
        }
        &header;
        print <<"EOT";
<table border=0 width=100% cellspacing=$frameborder bgcolor="$color{'frame'}">
<tr>
        <td bgcolor="$color{'titlebg'}"><font size=$Fontsize color="$color{'titletext'}" face="$FontFace"><b>$ManageBoards{'11'}</b></font></td>
</tr>
<tr>
        <td bgcolor="$color{'windowbg'}" width=140 valign=top><font size=$Fontsize face="$FontFace">
<form action="$cgi&action=reorderboards2" method="POST">
<b>$ManageBoards{'12'}:</b><br>
<textarea name="boards" cols="40" rows="4">$boardlist</textarea><br>
<input type=hidden name="firstline" value="$allboards[0]">
<input type=hidden name="secondline" value="$allboards[1]">
<input type=hidden name="cat" value="$INFO{'cat'}">
<input type=submit value="$ManageBoards{'11'}">
</form>
        </font></td>
</tr>
</table>
EOT
        &footer;
        exit;
}

sub ReorderBoards2 {
        &checkdomain;
        if($settings[7] ne "$Administrator") { &fatal_error("$ManageBoards{'10'}"); }
        $FORM{'boards'} =~ s/\r//g;
        $FORM{'firstline'} =~ s/\n//g;
        $FORM{'secondline'} =~ s/\n//g;
        open(FILE, ">$boardsdir/$FORM{'cat'}.cat");
        &lock(FILE);
        print FILE "$FORM{'firstline'}\n";
        print FILE "$FORM{'secondline'}\n";
        print FILE "$FORM{'boards'}";
        &unlock(FILE);
        close(FILE);
        print "Location: $cgi\&action=reorderboards\&cat=$FORM{'cat'}\n\n";
        exit;
}

sub ModifyBoard {
        &checkdomain;
        if($settings[7] ne "$Administrator") { &fatal_error("$ManageBoards{'10'}"); }
        if($FORM{'moda'} eq "$ManageBoards{'7'}") {
                open(FILE, ">$boardsdir/$FORM{'id'}.dat");
                &lock(FILE);
                print FILE "$FORM{'boardname'}\n";
                $FORM{'descr'} =~ s/\n/ /g;
                $FORM{'descr'} =~ s/\r//g;
                print FILE "$FORM{'descr'}\n";
                $FORM{'moderator'} =~ s/\s*,\s*/|/g;
                print FILE "$FORM{'moderator'}|\n";
                &unlock(FILE);
                close(FILE);
                print "Location: $cgi\&action=manageboards\n\n";
        } else {
                open(FILE, "$boardsdir/$FORM{'cat'}.cat");
                &lock(FILE);
                @categories = <FILE>;
                &unlock(FILE);
                close(FILE);
                $title = "$ManageBoards{'13'}";
                $newcatlist="";
                foreach $curboard (@categories) {
                        $curboard =~ s/\n//g;
                        if($curboard ne "$FORM{'id'}") { $newcatlist="$newcatlist$curboard\n"; }
                }
                open(FILE, ">$boardsdir/$FORM{'cat'}.cat");
                &lock(FILE);
                print FILE "$newcatlist";
                &unlock(FILE);
                close(FILE);
                &header;

                $curboard="$FORM{'id'}";
                open(BOARDDATA, "$boardsdir/$curboard.txt");
                &lock(BOARDDATA);
                @messages = <BOARDDATA>;
                &unlock(BOARDDATA);
                close(BOARDDATA);
                foreach $curmessage (@messages) {
                        ($id, $dummy) = split(/\|/, $curmessage);
                        unlink("$datadir/$id\.txt");
                        unlink("$datadir/$id\.mail");
                        print "$ManageBoards{'14'} $id<br>";
                }
                unlink("$boardsdir/$curboard.dat");
                unlink("$boardsdir/$curboard.txt");
                print "$ManageBoards{'15'}<br>";
                print "$ManageBoards{'16'}";
                &footer;
        }
        exit;
}

sub CreateBoard {
        &checkdomain;
        if($settings[7] ne "$Administrator") { &fatal_error("$ManageBoards{'10'}"); }
        $id="$FORM{'id'}";
        open(FILE, "$boardsdir/$FORM{'cat'}.cat");
        &lock(FILE);
        @categories = <FILE>;
        &unlock(FILE);
        close(FILE);
        open(FILE, ">$boardsdir/$FORM{'cat'}.cat");
        &lock(FILE);
        foreach $curboard (@categories) {
                $curboard =~ s/[\n\r]//g;
                print FILE "$curboard\n";
        }
        print FILE "$id";
        &unlock(FILE);
        close(FILE);
        open(FILE, ">$boardsdir/$id.dat");
        print FILE "$FORM{'boardname'}\n";
        $FORM{'descr'} =~ s/\n/ /g;
        $FORM{'descr'} =~ s/\r//g;
        print FILE "$FORM{'descr'}\n";
        $FORM{'moderator'} =~ s/\s*,\s*/|/g;
        print FILE "$FORM{'moderator'}|\n";
        close(FILE);
        open(FILE, ">$boardsdir/$id.txt");
        print FILE "";
        close(FILE);
        print "Location: $cgi\&action=manageboards\n\n";
        exit;
}


1;