###############################################################################
# Notify.pl                                                                   #
###############################################################################
# Yet another Bulletin Board (http://www.yabb.com.ru)                         #
# Open Source project started by Zef Hemel (zef@zefnet.com)                   #
# =========================================================================== #
# Copyright (c) The YaBB Programming team                                     #
# =========================================================================== #
# This file has been written by: Zef Hemel                                    #
###############################################################################

sub Notify {
        if($username eq "Guest") { &fatal_error("$Notify{'1'}"); }
        $title = "$Notify{'2'}";
        &header;
        &menu2;

        # Check, if User already gets a notification

        open (FILE, "$datadir/$INFO{'thread'}.mail");
        &lock(FILE);
        @mails = <FILE>;
        &unlock(FILE);
        close(FILE);

        $isonlist = 0;

        foreach $curmail (@mails) {
                $curmail =~ s/[\n\r]//g;
                if($settings[2] eq "$curmail") { $isonlist = 1; }
        }

        if ($isonlist){

        $msg="$Notify{'3'}\?";

        print <<"EOT";
<table border=0 width=100% cellspacing=$frameborder bgcolor="$color{'frame'}">
<tr>
        <td bgcolor="$color{'titlebg'}"><font size=$Fontsize face="$FontFace" color="$color{'titletext'}"><b>$Notify{'2'}</b></font></td>
</tr>
<tr>
        <td bgcolor="$color{'windowbg'}"><font size=$Fontsize face="$FontFace">
$msg<br>
<b><a href="$cgi&action=notify3&thread=$INFO{'thread'}">$Notify{'4'}</a> - <a href="$cgi&action=display&num=$INFO{'thread'}">$Notify{'5'}</a></b>
</font></td>
</tr>
</table>
EOT

        } else
        {

        print <<"EOT";
<table border=0 width=100% cellspacing=$frameborder bgcolor="$color{'frame'}">
<tr>
        <td bgcolor="$color{'titlebg'}"><font size=$Fontsize face="$FontFace" color="$color{'titletext'}"><b>$Notify{'2'}</b></font></td>
</tr>
<tr>
        <td bgcolor="$color{'windowbg'}"><font size=$Fontsize face="$FontFace">
$Notify{'6'}<br>
<b><a href="$cgi&action=notify2&thread=$INFO{'thread'}">$Notify{'4'}</a> - <a href="$cgi&action=display&num=$INFO{'thread'}">$Notify{'5'}</a></b>
</font></td>
</tr>
</table>
EOT

        }

        &footer;
        exit;
}

sub Notify2 {
        &checkdomain;
        if($username eq "Guest") { &error("$Notify{'1'}"); }
        $thread = $INFO{'thread'};
        open (FILE, "$datadir/$thread.mail");
        &lock(FILE);
        @mails = <FILE>;
        &unlock(FILE);
        close(FILE);
        open (FILE, ">$datadir/$thread.mail") || &fatal_error("$Notify{'7'} $thread.mail");
        &lock(FILE);
        print FILE "$settings[2]\n";
        foreach $curmail (@mails) {
                $curmail =~ s/[\n\r]//g;
                if($settings[2] ne "$curmail") { print FILE "$curmail\n"; }
        }
        &unlock(FILE);
        close(FILE);
        print "Location: $cgi\&action=display\&num=$thread\n\n";
        exit;
}

sub Notify3 {
        if($username eq "Guest") { &error("$Notify{'1'}"); }
        $thread = $INFO{'thread'};
        open (FILE, "$datadir/$thread.mail");
        &lock(FILE);
        @mails = <FILE>;
        &unlock(FILE);
        close(FILE);
        open (FILE, ">$datadir/$thread.mail") || &fatal_error("$Notify{'7'} $thread.mail");
        &lock(FILE);
        foreach $curmail (@mails) {
                $curmail =~ s/[\n\r]//g;
                if($settings[2] ne "$curmail") { print FILE "$curmail\n"; }
        }
        &unlock(FILE);
        close(FILE);
        print "Location: $cgi\&action=display\&num=$thread\n\n";
        exit;
}
1;
