###############################################################################
# RemoveOldThreads.pl                                                         #
###############################################################################
# Yet another Bulletin Board (http://www.yabb.com.ru)                         #
# Open Source project started by Zef Hemel (zef@zefnet.com)                   #
# =========================================================================== #
# Copyright (c) The YaBB Programming team                                     #
# =========================================================================== #
# This file has been written by: Zef Hemel                                    #
###############################################################################

sub RemoveOldThreads {
        &checkdomain;
        if($settings[7] ne "$Administrator") { &fatal_error("$RemoveOldThreads{'1'}"); }
        $title = "$RemoveOldThreads{'2'} $FORM{'maxdays'}";
        open(FILE, "$vardir/cat.txt");
        &lock(FILE);
        @categories = <FILE>;
        &unlock(FILE);
        close(FILE);
        open(FILE, ">$vardir/oldestmes.txt");
        &lock(FILE);
        print FILE "$FORM{'maxdays'}";
        &unlock(FILE);
        close(FILE);
        &header;
        &menu2;
        foreach $curcat (@categories) {
                $curcat =~ s/[\n\r]//g;
                open(CAT, "$boardsdir/$curcat.cat");
                &lock(CAT);
                @catinfo = <CAT>;
                &unlock(CAT);
                close(CAT);
                $catinfo[1] =~ s/[\n\r]//g;
                $curcatname="$catinfo[0]";
                foreach $curboard (@catinfo) {
                        if($curboard ne "$catinfo[0]" && $curboard ne "$catinfo[1]") {
                                $curboard =~ s/[\n\r]//g;
                                open(BOARDDATA, "$boardsdir/$curboard.txt");
                                &lock(BOARDDATA);
                                @messages = <BOARDDATA>;
                                &unlock(BOARDDATA);
                                close(BOARDDATA);
                                open(BOARDDATA, ">$boardsdir/$curboard.txt");
                                for ($a = 0; $a < @messages; $a++) {
                                        ($num, $dummy, $dummy, $dummy, $lp) = split(/\|/, $messages[$a]);
                                        $date1 = "$lp";
                                        $date2 = "$date";
                                        &calcdifference2;
                                        if($result <= $FORM{'maxdays'}) { # If the message is not to old
                                                print BOARDDATA "$messages[$a]";
                                                print "$num = $result $RemoveOldThreads{'3'}<br>";
                                        } else {
                                                print "$num = $result $RemoveOldThreads{'3'} ($RemoveOldThreads{'4'})<br>";
                                                unlink("$datadir/$num.txt");
                                                unlink("$datadir/$num.mail");
                                                                                                unlink("$datadir/$num.data");
        open(LASTPOST, "$vardir/recentpost.txt");
        &lock(LASTPOST);
        @recentpost = <LASTPOST>;
        &unlock(LASTPOST);
        close(LASTPOST);

        open(LASTPOST, ">$vardir/recentpost.txt");
        &lock(LASTPOST);
        foreach $line(@recentpost) {
                @post = split(/\|/,$line);
                if ($post[0] ne $num)
                {
                        print LASTPOST $line;
                }
        }
        &unlock(LASTPOST);
        close(LASTPOST);

        # Remove Entries in recentpost.txt

        open(LASTPOST, "$vardir/recentpost.htm");
        &lock(LASTPOST);
        @recentpost = <LASTPOST>;
        &unlock(LASTPOST);
        close(LASTPOST);

        $test="num=$num\"";

        open(LASTPOST, ">$vardir/recentpost.htm");
        &lock(LASTPOST);
        foreach $line(@recentpost)
        {
                @post = split(/\|/,$line);
                if(!($line =~ /$test/))
                {
                        print LASTPOST $line;
                }
        }
        &unlock(LASTPOST);
        close(LASTPOST);
                                        }
                                }
                                close(BOARDDATA);
                        }
                }
        }
        &footer;
        exit;
}

1;
