###############################################################################
# RemoveThread.pl                                                             #
###############################################################################
# Yet another Bulletin Board (http://www.yabb.com.ru)                         #
# Open Source project started by Zef Hemel (zef@zefnet.com)                   #
# =========================================================================== #
# Copyright (c) The YaBB Programming team                                     #
# =========================================================================== #
# This file has been written by: Zef Hemel                                    #
###############################################################################

sub RemoveThread {
        $title = "$RemoveThread{'1'}";
        &header;
        &menu2;
        print <<"EOT";
<table border=0 width=100% cellspacing=$frameborder bgcolor="$color{'frame'}">
<tr>
        <td bgcolor="$color{'titlebg'}"><font size=$Fontsize color="$color{'titletext'}" face="$FontFace"><b>$RemoveThread{'1'}</b></font></td>
</tr>
<tr>
        <td bgcolor="$color{'windowbg'}"><font size=$Fontsize face="$FontFace">
$RemoveThread{'2'}<br>
<b><a href="$cgi&action=removethread2&thread=$INFO{'thread'}">$RemoveThread{'3'}</a> - <a href="$cgi&action=display&num=$INFO{'thread'}">$RemoveThread{'4'}</a></b>
</font></td>
</tr>
</table>
EOT
        &footer;
        exit;
}

sub RemoveThread2 {
        &checkdomain;
        $thread = $INFO{'thread'};
        if($moderators{$username} eq "" && $settings[7] ne "Administrator") {
                &fatal_error("$RemoveThread{'5'}");
        }

        open (FILE, "$boardsdir/$currentboard.txt") || &fatal_error("$RemoveThread{'6'} $currentboard.dat");
        &lock(FILE);
        @threads = <FILE>;
        &unlock(FILE);
        close (FILE);
        open (FILE, ">$boardsdir/$currentboard.txt") || &fatal_error("$RemoveThread{'6'} $currentboard.dat");
        &lock(FILE);
        for ($a = 0; $a < @threads; $a++) {
                ($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mattach) = split(/\|/,$threads[$a]);
                $mattach =~ s/[\n\r]//g;
                if ($mnum ne "$thread") { print FILE "$threads[$a]"; }
        }
        &unlock(FILE);
        close(FILE);
        open(LASTPOST, "$vardir/recentpost.txt");
        &lock(LASTPOST);
        @recentpost = <LASTPOST>;
        &unlock(LASTPOST);
        close(LASTPOST);

        open(LASTPOST, ">$vardir/recentpost.txt");
        &lock(LASTPOST);
        foreach $line(@recentpost) {
                @post = split(/\|/,$line);
                if ($post[0] ne $INFO{'thread'})
                {
                        print LASTPOST $line;
                }
        }
        &unlock(LASTPOST);
        close(LASTPOST);

        # Remove Entries in recentpost.txt

        open(LASTPOST, "$vardir/recentpost.htm");
        &lock(LASTPOST);
        @recentpost = <LASTPOST>;
        &unlock(LASTPOST);
        close(LASTPOST);

        $test="num=$thread\"";

        open(LASTPOST, ">$vardir/recentpost.htm");
        &lock(LASTPOST);
        foreach $line(@recentpost)
        {
                @post = split(/\|/,$line);
                if(!($line =~ /$test/))
                {
                        print LASTPOST $line;
                }
        }
        &unlock(LASTPOST);
        close(LASTPOST);
        unlink("$datadir/$thread.txt");
        unlink("$datadir/$thread.mail");
        unlink("$datadir/$thread.data");
        print "Location: $cgi\n\n";
        exit;
}

1;
